
def minimal_combination(self):
    res = {}
    pricelist = request.env["website"].get_current_website().get_current_pricelist()
    product_id, add_qty, has_distinct_price = self._get_cheapest_info(pricelist)

    combination = self._get_combination_info(
        product_id=product_id, 
        add_qty=add_qty, 
        pricelist=pricelist
    ) or {}

    # Force initialize combination_info with safe defaults if not already set
    combination_info = combination if isinstance(combination, dict) else {}

    if combination_info:
        res.update(
            minimal_price=combination_info.get('price', 0.0),
            minimal_list_price=combination_info.get('list_price', 0.0),
            has_discounted_price=combination_info.get('has_discounted_price', False),
            variants_id=int(product_id),
            variants_ids=self.product_variant_ids,
        )
    else:
        res.update(
            minimal_price=0.0,
            minimal_list_price=0.0,
            has_discounted_price=False,
            variants_id=int(product_id),
            variants_ids=self.product_variant_ids,
        )

    return res

def _get_product_subpricelists(self, pricelist_id):
    return pricelist_id.item_ids.filtered(
        lambda i: (
            i.applied_on == "3_global"
            or (
                i.applied_on == "2_product_category" and i.categ_id == self.categ_id
            )
            or (i.applied_on == "1_product" and i.product_tmpl_id == self)
            or (
                i.applied_on == "0_product_variant"
                and i.product_id in self.product_variant_ids
            )
        )
    )
